# Google Summer of Code

Kubernetes is happy to announce that we have participated in the Google Summer of Code (GSoC) program
under the Cloud Native Computing Foundation (CNCF) in 2017 and 2018 and as an independent organization
in 2015. The details for 2019 can be found [here](https://github.com/cncf/soc#kubernetes).

Please see the [main program page](https://summerofcode.withgoogle.com/) for general information about the program,
such as its purpose, timeline, eligibility requirements, and how to apply.

## What is Kubernetes?

Kubernetes is an open-source system for automating deployment, scaling, and management of containerized applications.
It groups containers that make up an application into logical units for easy management and discovery.
Kubernetes builds upon 15 years of experience of running production workloads at Google, combined with best-of-breed ideas and practices from the community.
Please see [kubernetes.io](https://kubernetes.io/) for more details.

## What are SIGs?

Kubernetes is a set of projects, each shepherded by a special interest group (SIG).
To get a grasp of the projects that we work on, check out the complete [list of SIGs](/sig-list.md).

This [slide deck](https://docs.google.com/presentation/d/1JqcALpsg07eH665ZXQrIvOcin6SzzsIUjMRRVivrZMg) provides an overview of how the Kubernetes community is organized.

## Communication

- Mailing List: development announcements and discussions appear on the Google group `kubernetes-dev` (send mail to kubernetes-dev@googlegroups.com).
- Slack: #gsoc-apps channel on the Kubernetes Slack. You can get an invite [here](http://slack.k8s.io/).

## Contribute

As part of the application process, the Google Summer of Code program recommends that candidates make small contributions to the project they intend to apply for.
To start working on the project, make sure to fill out the [CLA](/CLA.md) and check if you have the right environment with this guide.
The README in the [community repo](https://github.com/kubernetes/community) details these things and more.

## Guides

Google Summer of Code provides official guides for [students](https://google.github.io/gsocguides/student/) and [mentors](https://google.github.io/gsocguides/mentor/).

Please read the guides and [FAQs](https://developers.google.com/open-source/gsoc/faq) to get an idea of what it means to participate in the program.

## Coordination

| **Name** | **Slack** | **Email** |
|----------|-----------|-----------|
| [Ihor Dvoretskyi](https://github.com/idvoretskyi) | @ihor.dvoretskyi | ihor@cncf.io |
| [Nikhita Raghunath](https://github.com/nikhita) | @nikhita | nikitaraghunath@gmail.com |
| [Paris Pittman](https://github.com/parispittman) | @paris |  parispittman@google.com |

The coordinators can be contacted at any time. The easiest way is to send a slack message.

Do you have an idea for a task that is suitable for this program? Contact the mentors or coordinators!
Or even better, volunteer for mentoring an intern during the work on your idea!

## Past Participation

Kubernetes has participated in Google Summer of Code in [2018](https://summerofcode.withgoogle.com/organizations/6453865516367872/) and [2017](https://summerofcode.withgoogle.com/archive/2017/organizations/6018829461225472/) as a part of CNCF and in [2015](https://www.google-melange.com/archive/gsoc/2015/orgs/kubernetes) as an independent organization.

To get an idea about the projects, you can take a look at the list of project ideas published for GSoC [2017](https://github.com/cncf/soc/blob/master/2017.md#kubernetes) and [2018](https://github.com/cncf/soc/blob/master/2018.md#kubernetes).

## Code of Conduct

Kubernetes abides by the [Code of Conduct](/code-of-conduct.md).
